
#pragma once

#include "acfg.h"
#include "pmf.h"
#include "ibitstream.h"


class ADec
{
public:
  ADec  ( const ACfg& acfg, std::string& inname );
  ~ADec ();

  bool      isValid       ()                  const { return valid; }
  bool      moreSymbols   ()                  const { return numToBeDecoded > 0; }
  uint32_t  getNumDecoded ()                  const { return numSymbols - numToBeDecoded; }
  uint8_t   decode        ( const Pmf& pmf );

private:

private:
  //--- general variables ---
  const bool      prefix;
  const uint32_t  V;
  const uint32_t  U;
  IBitstream      bitstream;
  bool            valid;
  uint32_t        numSymbols;
  uint32_t        numToBeDecoded;

  //--- members for arithmetic coding engine ---
};
