
#pragma once

#include <cstdint>
#include <cassert>


class Alphabet
{
public:
  virtual ~Alphabet() {}
  virtual uint8_t getIndex  ( uint8_t symbol )  const = 0;
  virtual uint8_t getSymbol ( uint8_t index  )  const = 0;
};


class AlpbabetABCD : public Alphabet
{
public:
  AlpbabetABCD();
  uint8_t getIndex  ( uint8_t symbol ) const { uint8_t index = symbol2index[ symbol ]; 
                                               assert( index < 4 ); return index; }
  uint8_t getSymbol ( uint8_t index  ) const { assert( index < 4 ); return index2symbol[ index  ];  }
private:
  uint8_t symbol2index[ 256 ];
  uint8_t index2symbol[ 256 ];
};


class Alphabet256 : public Alphabet
{
public:
  Alphabet256() {}
  uint8_t getIndex  ( uint8_t symbol ) const { return symbol; }
  uint8_t getSymbol ( uint8_t index  ) const { return index;  }
};

