
#pragma once

#include <cstdint>
#include <fstream>
#include <string>


class IBitstream
{
public:
  IBitstream  ( std::string& filename );
  ~IBitstream ();

  bool      isValid       ()  const { return valid; }
  uint32_t  getNumSymbols ()  const { return numSymbols; }
  uint8_t   getBit        ();

private:
  std::ifstream   file;
  bool            valid;
  bool            eofread;
  uint32_t        numSymbols;
  uint8_t         nextBits;
  uint8_t         numNextBits;
};
